//
//  LKSysInfoPlugin+PreferencesExtensions.h
//  LKSysInfoPlugin
//
//  Created by Nicholas Penree on 5/26/08.
//  Copyright 2008 Conceited Software. All rights reserved.
//

#import <Cocoa/Cocoa.h> 

extern NSString *LKSysInfoDebugKey; 
extern NSString *LKSysInfoHostnameKey;
extern NSString *LKSysInfoUsernameKey;
extern NSString *LKSysInfoCPUSpeedKey;
extern NSString *LKSysInfoRAMKey;
extern NSString *LKSysInfoModelKey; 
extern NSString *LKSysInfoL2Key; 
extern NSString *LKSysInfoTimeKey;
extern NSString *LKSysInfoLoadAvgKey; 
extern NSString *LKSysInfoStyleKey; 
extern NSString *LKSysInfoClientKey; 
extern NSString *LKSysInfoUptimeKey; 
extern NSString *LKSysInfoUseBoldKey; 
extern NSString *LKSysInfoSeparatorKey; 
extern NSString *LKSysInfoOSXKey; 
extern NSString *LKSysInfoSerialKey; 

@interface NSObject (LKSysInfoPlugin_PreferencesExtensions)

- (NSMutableDictionary *)preferences;
- (void)setPreferences:(NSMutableDictionary *)preferences;
- (NSString *)preferencesPath;

- (BOOL)isDebugMode;
- (NSNumber *)showHostname;
- (NSNumber *)showUsername;
- (NSNumber *)showCPUSpeed;
- (NSNumber *)showModel;
- (NSNumber *)showL2Cache;
- (NSNumber *)showRAM;
- (NSNumber *)showTime;
- (NSNumber *)showLoadAvgs;
- (NSNumber *)showLinkinusStyle;
- (NSNumber *)showLinkinusVersion;
- (NSNumber *)showOSXVersion;
- (NSNumber *)showUptime;
- (NSNumber *)showSerial;
- (NSString *)separator;
- (NSNumber *)useBoldForLabels;

- (void)setShowHostname:(NSNumber *)showHostname;
- (void)setShowUsername:(NSNumber *)showUsername;
- (void)setShowCPUSpeed:(NSNumber *)showCPUSpeed;
- (void)setShowModel:(NSNumber *)showModel;
- (void)setShowL2Cache:(NSNumber *)showL2Cache;
- (void)setShowRAM:(NSNumber *)showRAM;
- (void)setShowTime:(NSNumber *)showTime;
- (void)setShowLoadAvgs:(NSNumber *)showLoadAvgs;
- (void)setShowLinkinusStyle:(NSNumber *)showLinkinusStyle;
- (void)setShowLinkinusVersion:(NSNumber *)showLinkinusVersion;
- (void)setShowOSXVersion:(NSNumber *)showOSXVersion;
- (void)setShowUptime:(NSNumber *)showUptime;
- (void)setShowSerial:(NSNumber *)showSerial;
- (void)setSeparator:(NSString *)separator;
- (void)setUseBoldForLabels:(NSNumber *)useBoldForLabels;

@end
